import { createApp } from 'vue'
import Antd from 'ant-design-vue'
// 导入组件
import AudioPreview from './BoxMask.vue'
import snowy from '@/snowy'
let audioPreviewInstance = null
let audioPreviewApp = null

/**
 * 初始化音频预览实例
 * @param {Array} audioList 音频列表
 * @param {Number} defaultIndex 当前查看的音频索引
 * @param {Function} callback 回调函数
 */
const initInstanceAudioPreview = (audioList, defaultIndex, callback) => {
	const mountNode = document.createElement('div')
	audioPreviewApp = createApp(AudioPreview, {
		audioList,
		defaultIndex,
		callback
	})
	// 注册 Ant Design Vue 组件
	audioPreviewApp.use(Antd)
	audioPreviewApp.use(snowy)
	audioPreviewInstance = audioPreviewApp.mount(mountNode)
	return mountNode
}

/**
 * 音频预览 Promise 函数
 * @param {Object} obj 包含音频列表和默认索引的对象
 * @returns {Promise} 抛出确认和取消回调函数
 */
const showAudioPreviewBox = (obj) => {
	// 非首次调用服务时，在 DOM 中移除上个实例
	if (audioPreviewInstance !== null && audioPreviewApp !== null) {
		audioPreviewApp.unmount()
		audioPreviewInstance = null
		audioPreviewApp = null
	}

	let { audioList, defaultIndex } = obj
	return new Promise((resolve) => {
		const mountNode = initInstanceAudioPreview(audioList, defaultIndex, (res) => {
			resolve(res)
			// 服务取消时卸载 DOM
			if (res === 'cancel' && audioPreviewInstance !== null) {
				audioPreviewApp.unmount()
				document.body.removeChild(mountNode)
				audioPreviewInstance = null
				audioPreviewApp = null
			}
		})

		document.body.appendChild(mountNode) // 挂载 DOM
		// 使用 setTimeout 确保组件已完全挂载
		setTimeout(() => {
			if (audioPreviewInstance) {
				audioPreviewInstance.visible = true // 打开音频预览遮罩层
			}
		}, 0)
	})
}

export default showAudioPreviewBox
